#include <stdio.h>
#include <string.h>
#include <stdlib.h>

static void decrypt_dw2(unsigned char *rom)
{
	int i;
	unsigned short *src = (unsigned short*)rom;
	
	for (i = 0; i < 0x80000/2; i++) {
		unsigned short x = src[i];

		if ((i & 0x020890) == 0x000000)				      			  x ^= 0x0002;
		if ((i & 0x020000) == 0x020000 && (i & 0x001500) != 0x001400) x ^= 0x0002;
		if ((i & 0x020400) == 0x000000 && (i & 0x002010) != 0x002010) x ^= 0x0400;
		if ((i & 0x020000) == 0x020000 && (i & 0x000148) != 0x000140) x ^= 0x0400;

		src[i] = x;
	}
}

static void remove_tamper_protection(unsigned char *rom, int length)
{
#define extract_xy			\
		int x = (opcode >> 9) & 7;	\
		int y = (opcode >> 0) & 7;

#define read_long(address) ((mem16[(((address)-0x100000)/2)+0] << 16) | (mem16[(((address)-0x100000)/2)+1] << 0))

	int i;
	unsigned short addr_data[0x100];
	unsigned int Ax[8];
	unsigned int Dx[8];
	unsigned short addr_data_bak[0x100];
	unsigned int Ax_bak[8];
	unsigned int Dx_bak[8];
	
	unsigned short *mem16 = (unsigned short*)rom;
	
	for (i = 0; i < length/2; i++)
	{
		int j=0,counter = 0;
		if (mem16[i] == 0x2d7c) {
			counter = 1;
			for (j = 4; j < 32; j++) {
				if (mem16[i+j] == 0x2d7c) {
					j += 3;
					counter++;
				}
			}
		}
		
		if (counter <= 3) {
			i = i + j;
			continue;
		}
		else if (counter >= 4)
		{
			memset (Dx, 0xff, sizeof(Dx));
			memset (Ax, 0xff, sizeof(Ax));
			memset (addr_data, 0xff, sizeof(addr_data));
			
			int test_zero = 0;
			int test_lessthan = 0;
			int andi0003 = 0;

			int k = i;
			while (1)
			{
				unsigned short opcode = mem16[k];

				// we hit the jsr
				if (opcode == 0x4eb9) {
					i = k + 2;
					break;
				}

				if (opcode == 0x2d7c) // move.l	#$#######, ($x,A6)
				{
					unsigned short addr = (0x100 - ((0-mem16[k+3]) & 0xfe)) >> 1;
			
					addr_data[addr+0] = mem16[k+1];
					addr_data[addr+1] = mem16[k+2];
					k+=4;
					continue;
				}

				if ((opcode & 0xf1ff) == 0x203c) // 2E3C 5B69 91EE           move.l  #$5b6991ee, D7
				{
					extract_xy
					Dx[x] = (mem16[k+1] << 16) | mem16[k+2];
					k+=3;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x2068) // movea.l ($x,Ay), Ax
				{
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					Ax[x] = (addr_data[addr+0] << 16) | (addr_data[addr+1]);
					k+=2;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x2040) // 2447                     movea.l D7, A2
				{
					extract_xy
					Ax[x] = Dx[y];
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xd1e8) // adda.l  (-$10,Ay), Ax
				{
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					Ax[x] += (addr_data[addr+0] << 16) | (addr_data[addr+1]);
					k+=2;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xd1c0) // D5C7                     adda.l  D7, A2
				{
					extract_xy
					Ax[x] += Dx[y];
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x3028) //  move.w  (-$12,Ay), Dx
				{
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					Dx[x] = (Dx[x] & 0xffff0000) | addr_data[addr];
					k+=2;
					continue;
				}
			
				if ((opcode & 0xf1f8) == 0xd068) //  add.w  (-$12,Ay), Dx
				{
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					Dx[x] = (Dx[x] & 0xffff0000) | (((Dx[x] & 0xffff) + addr_data[addr]) & 0xffff);
					k+=2;
					continue;
				}
			
				if ((opcode & 0xf1f8) == 0x9068) //  sub.w  (-$12,Ay), Dx
				{
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					Dx[x] = (Dx[x] & 0xffff0000) | (((Dx[x] & 0xffff) - addr_data[addr]) & 0xffff);
					k+=2;
					continue;
				}
			
				if ((opcode & 0xf1f8) == 0x9040) //  9647                     sub.w   D7, D3
				{
					extract_xy
					Dx[x] = (Dx[x] & 0xffff0000) | (((Dx[x] & 0xffff) - (Dx[y] & 0xffff)) & 0xffff);
					k++;
					continue;
				}
					
				if ((opcode & 0xf1f8) == 0x3000) //	 3003                      move.w  D3, D0
				{ 
					extract_xy
					Dx[x] = (Dx[x] & 0xffff0000) | (Dx[y] & 0xffff);
					k++;
					continue;
				}
			
				if ((opcode & 0xfff8) == 0x0240) // 0240 0003                andi.w  #$3, D0
				{ 
					int x = opcode & 7;
			
					if (x == 0 && mem16[k+1] == 3) {
						memcpy (Dx_bak, Dx, 8*4);
						memcpy (Ax_bak, Ax, 8*4);
						memcpy (addr_data_bak, addr_data, 0x100*2);
						andi0003 = k + (length/2);
					}
			
					Dx[x] &= 0xffff0000 | mem16[k+1];
					test_zero = Dx[x] & 0xffff;
					k+=2;
					continue;
				}
			
				if ((opcode & 0xfe00) == 0x6600) { // 670A                     beq/bne     $101346
					int take_branch = 0;
					int big_branch = 0;
					int z = k;
					k++;
					if (opcode & 0x100) {
						if (test_zero) continue; // not zero
					} else {
						if (!test_zero) continue; // zero
					}
					if (opcode & 0xff) {
						int offset = (opcode & 0x7e) >> 1;
						k += (opcode & 0x80) ? -((0-offset)&0x3f) : offset;
					} else {
						big_branch = mem16[k];
						int offset = (mem16[k+1] & 0x7ffe) >> 1;
						k += (mem16[k+1] & 0x8000) ? -(offset ^ 0x3fff) : offset;
						take_branch = 1;
					}
						
					if (opcode == 0x6700) {
						for (int g = 0; g < 8; g++) {
							if (Ax[g] != Ax_bak[g]) {									
								//123EF2: 207C 0081 3E5C           movea.l #$813e5c, A0
								mem16[andi0003+0] = 0x207c | (g << 9);
								mem16[andi0003+1] = Ax[g] >> 16;
								mem16[andi0003+2] = Ax[g] & 0xffff;
								andi0003+=3;
							}
						}

						for (int g = 0; g < 8; g++) {
							if (Dx[g] != Dx_bak[g]) {								
								mem16[andi0003+0] = 0x203C | (g << 9);
								mem16[andi0003+1] = Dx[g] >> 16;
								mem16[andi0003+2] = Dx[g] & 0xffff;			
								andi0003+=3;
							}
						}

						for (int g = 0; g < 256; g++) {
							if (addr_data[g] != addr_data_bak[g]) {
								mem16[andi0003+0] = 0x3d7c;// | (g << 9);
								mem16[andi0003+1] = addr_data[g];
								mem16[andi0003+2] = (0x100-(0-(g*2)))|0xff00;
								andi0003+=3;
							}
						}
						
						mem16[andi0003+0] = 0x6000;
						mem16[andi0003+1] = big_branch + (z*2) - ((andi0003-(length/2))*2);
			
						i = z+2;
						break;
					}
						
					continue;
				}
					
				if ((opcode & 0xff00) == 0x6000) { // 600A                     bra     $101346
					k++;
					int offset = (opcode & 0x7e) >> 1;
					k += (opcode & 0x80) ? -((0-offset)&0x3f) : offset;
					continue;
				}
					
				if ((opcode & 0xff00) == 0x6300) { // 101368: 63EC             bls     $101356
					k++;
					if (test_lessthan || test_zero == 0) {
						int offset = (opcode & 0x7e) >> 1;
						k += (opcode & 0x80) ? -((0-offset)&0x3f) : offset;
					}
					continue;
				}
						
				if ((opcode & 0xf180) == 0x7000) { // 						   moveq  #$##, Dx
					int x = (opcode >> 9) & 7;
					Dx[x] =  opcode & 0x7f;
					if (opcode & 0x80) Dx[x] |= 0xffffff80;
					k++;
					continue;
				}

													   // E588                     lsl.l   #2, D0
				if ((opcode & 0xf088) == 0xe088) { // E488 					   lsr.l   #2, D0
					extract_xy
					if (opcode & 0x100) {
						Dx[y] <<= x;
					} else {
						Dx[y] >>= x;
					}
					k++;
					continue;
				}

				if ((opcode & 0xf180) == 0x5040) { // 5246                     addq.w  #1, D6
					extract_xy
					Dx[y] = (Dx[y] & 0xffff0000) | (((Dx[y] & 0xffff) + x) & 0xffff);
					k++;
					continue;
				}

				if ((opcode & 0xfff8) == 0x42A8) { // 42AE FFD2                clr.l   (-$2e,A6)
					int x = opcode & 7;
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					addr_data[addr+0] = addr_data[addr+1] = 0;
					k+=2;
					continue;
				}

				if ((opcode & 0xfff8) == 0x4240) { // 4246 						clr.w	D6
					int x = opcode & 7;
					Dx[x] &= 0xffff0000;
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x2028) { // 202E FFE4                move.l  (-$1c,A6), D0
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					Dx[x] = (addr_data[addr+0] << 16) | (addr_data[addr+1] << 0);
					k += 2;
					continue;
				}

				if ((opcode & 0xfff8) == 0x2d40) { // 2D40 FFD2                move.l  D0, (-$2e,A6)
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					addr_data[addr+0] = Dx[y] >> 16;
					addr_data[addr+1] = Dx[y] & 0xffff;
					k += 2;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x2010) { // 2012                     move.l  (A2), D0
					extract_xy
					Dx[x] = read_long(Ax[y]);
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x2000) { // 2207                     move.l  D7, D1
					extract_xy
					Dx[x] = Dx[y];
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xB1A8) { // B1AE FFE4                eor.l   D0, (-$1c,A6)
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					addr_data[addr+0] ^= Dx[x] >> 16;
					addr_data[addr+1] ^= Dx[x] & 0xffff;
					k += 2;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xB180) { // B185                     eor.l   D0, D5
					extract_xy
					Dx[y] ^= Dx[x];
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xd1a8) { // D3AE FFD8                add.l   D1, (-$28,A6)
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					unsigned int a = ((addr_data[addr+0] << 16) | addr_data[addr+1]) + Dx[x];
					addr_data[addr+0] = a >> 16;
					addr_data[addr+1] = a & 0xffff;
					k += 2;
					continue;
				}

												   // DA9A                     add.l   (A2)+, D5
				if ((opcode & 0xf1f0) == 0xd090) { // D092                     add.l   (A2), D0
					extract_xy
					Dx[x] += read_long(Ax[y]);
					if (opcode & 0x0008) Ax[y] += 4;
					k++;
					continue;
				}

												   // 9E9A                     sub.l   (A2)+, D7
				if ((opcode & 0xf1f0) == 0x9090) { // 9A92                     sub.l   (A2), D5
					extract_xy
					Dx[x] -= read_long(Ax[y]);
					if (opcode & 0x0008) Ax[y] += 4;
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x91a8) { // 93AE FFE0                sub.l   D1, (-$20,A6)
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					unsigned int a = ((addr_data[addr+0] << 16) | addr_data[addr+1]) - Dx[x];
					addr_data[addr+0] = a >> 16;
					addr_data[addr+1] = a & 0xffff;
					k += 2;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xc090) { // C092                     and.l   (A2), D0
					extract_xy
					Dx[x] &= read_long(Ax[y]);
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xd080) { // DE80                     add.l   D0, D7
					extract_xy
					Dx[x] += Dx[y];
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x9080) { // 9e80                     sub.l   D0, D7
					extract_xy
					Dx[x] -= Dx[y];
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x8090) { // 8092                     or.l    (A2), D0
					extract_xy
					Dx[x] |= read_long(Ax[y]);
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x8080) { // 8087                     or.l    D7, D0
					extract_xy
					Dx[x] |= Dx[y];
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x5088) { // 588A                     addq.l  #4, A2
					extract_xy
					Ax[y] += x; // needs bigger range?
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0x5040) { // 5246                     addq.w  #1, D6
					extract_xy
					Dx[y] = (Dx[y] & 0xffff0000) | (((Dx[y] & 0xffff) + x) & 0xffff); // needs bigger range?
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xb040) { // BC44                     cmp.w   D4, D6
					extract_xy
					int d4 = (short)(Dx[y] & 0xffff);
					int d6 = (short)(Dx[x] & 0xffff);
					test_lessthan = (d6 < d4) ? 1 : 0;
					test_zero = ((d6 & 0xffff) - (d4 & 0xffff)) & 0xffff;
					k++;
					continue;
				}

				if ((opcode & 0xf1f8) == 0xb0a8) { // BAAE FFFC                cmp.l   (-$4,A6), D5
					extract_xy
					unsigned short addr = (0x100 - ((0-mem16[k+1]) & 0xfe)) >> 1;
					unsigned int d5 = Dx[x];
					unsigned int z = (addr_data[addr+0] << 16) | (addr_data[addr+1]);
			
					d5 -= z;
					test_zero = d5 ? 1 : 0;
					k+=2;
					continue;
				}

				k++;
			}
		}
	}
}

// remove copy protection
static void drgw2_patch(unsigned char *rom)
{
	int i;
	unsigned short *mem16 = (unsigned short*)rom;
	
	for (i = 0; i < 0x80000/2; i++)
	{
// remove bitswap protection reads
		if (mem16[i] == 0x0239 && mem16[i+1] == 0x7f && mem16[i+2] == 0x80 && mem16[i+3] == 0xcb79 &&	// 0239 007F 0080 CB79      andi.b  #$7f, $80cb79.l
			mem16[i+4] == 0x8139 && mem16[i+5] == 0x80 && mem16[i+6] == 0xcb79 && 						// 8139 0080 CB79           or.b    D0, $80cb79.l
			mem16[i+7] == 0x3039 && mem16[i+8] == 0x80 && mem16[i+9] == 0xcb78 &&						// 3039 0080 CB78           move.w  $80cb78.l, D0
			mem16[i+10]== 0xb079 && mem16[i+11]== 0x80 && mem16[i+12]== 0xcb68 &&						// B079 0080 CB68           cmp.w   $80cb68.l, D0
			mem16[i+13]== 0x6700 && mem16[i+15] == 0x4eb9)												// beq x, jsr x
		{
			mem16[i] &= 0xf0ff; // beq -> bra
		}

// remove bad jsr's
		if (mem16[i] == 0x4e90 && mem16[i+1] == 0x207c && (mem16[i+2] & 0xfff8) == 0x0010)
		{
			mem16[i] = 0x4e93;	// jsr (A0) -> (A3)
		}

// remove other protection reads/writes (optional)
#if 1
		if (mem16[i] == 0x30bc && /*mem16[i+1] == 0xf2 && */
			mem16[i+2] == 0x2079 && mem16[i+3] == 0x0080 && mem16[i+4] == 0xCB62 &&
			mem16[i+5] == 0x30b9 && mem16[i+6] == 0x0080 && mem16[i+7] == 0xcb68)
		{
			// 1069AC: 30BC 00F2                move.w  #$f2, (A0)
			mem16[i+0] = mem16[i+1] = 0x4e71;

			// 1069B6: 30B9 0080 CB68           move.w  $80cb68.l, (A0)
			mem16[i+5] = mem16[i+6] = mem16[i+7] = 0x4e71;
		}

		if (mem16[i] == 0x3080 &&
			mem16[i+1] == 0x2079 && mem16[i+2] == 0x0080 && mem16[i+3] == 0xCB62 &&
			mem16[i+4] == 0x30b9 && mem16[i+5] == 0x0080 && mem16[i+6] == 0xcb68)
		{
			// 104BC6: 3080                     move.w  D0, (A0)
			mem16[i+0] = 0x4e71;

			// 1069B6: 30B9 0080 CB68           move.w  $80cb68.l, (A0)
			mem16[i+4] = mem16[i+5] = mem16[i+6] = 0x4e71;
		}

		if (mem16[i] == 0x30bc && mem16[i+1] < 0x100 &&
			mem16[i+2] == 0x2079 && mem16[i+3] == 0x0080 && mem16[i+4] == 0xCB62 &&
			mem16[i+5] == 0x3010)
		{
			// 12B5D2: 30BC 0040                move.w  #$40, (A0)
			mem16[i+0] = mem16[i+1] = 0x4e71;

			// 12B5DC: 3010                     move.w  (A0), D0
			mem16[i+5] = 0x4e71;
		}

		if (i >= 0x2b2d0/2 && i < 0x2b3e4/2)
		{
			if (mem16[i] == 0x30bc && mem16[i+1] < 0x10 && mem16[i+0x9] == 0x3080)
			{
				// 12B2D0: 30BC 0008                move.w  #$8, (A0)
				mem16[i+0] = mem16[i+1] = 0x4e71;

				// 12B2E2: 3080                     move.w  D0, (A0)
				mem16[i+0x9] = 0x4e71;
			}
		}

		if (mem16[i] == 0x30bc && mem16[i+1] == 0x20 &&
			mem16[i+2] == 0x2079 && mem16[i+3] == 0x0080 && mem16[i+4] == 0xCB62 &&
			mem16[i+5] == 0x4250)
		{
			// 12B730: 30BC 0020                move.w  #$20, (A0)
			mem16[i+0] = mem16[i+1] = 0x4e71;

			// 12B73A: 4250                     clr.w   (A0)
			mem16[i+5] = 0x4e71;
		}
#endif
	}
}

int main()
{
	unsigned char *rom = (unsigned char*)malloc(0x100000);
	
	FILE *fa = fopen("dragon_ii_v-110x.u2", "rb");
	fread(rom, 0x80000, 1, fa);
	fclose (fa);

	decrypt_dw2(rom);

	memcpy (rom + 0x80000, rom, 0x80000);

	remove_tamper_protection(rom, 0x80000);

	memcpy (rom, rom + 0x80000, 0x80000);

	drgw2_patch(rom);

	fa = fopen("drgw2_deprotected.bin", "wb");
	fwrite (rom, 0x80000, 1, fa);
	fclose (fa);

	free (rom);
}
